var googleapi = {
    authorize: function(options) {
        var deferred = $.Deferred();

        //Build the OAuth consent page URL
        var authUrl = 'https://accounts.google.com/o/oauth2/auth?' + $.param({
            client_id: options.client_id,
            redirect_uri: options.redirect_uri,
            response_type: 'code',
            scope: options.scope
        });

        //Open the OAuth consent page in the InAppBrowser
        var authWindow = window.open(authUrl, '_blank', 'location=no,toolbar=no');

        //The recommendation is to use the redirect_uri "urn:ietf:wg:oauth:2.0:oob"
        //which sets the authorization code in the browser's title. However, we can't
        //access the title of the InAppBrowser.
        //
        //Instead, we pass a bogus redirect_uri of "http://localhost", which means the
        //authorization code will get set in the url. We can access the url in the
        //loadstart and loadstop events. So if we bind the loadstart event, we can
        //find the authorization code and close the InAppBrowser after the user
        //has granted us access to their data.
        $(authWindow).on('loadstart', function(e) {
            var url = e.originalEvent.url;
            var code = /\?code=(.+)$/.exec(url);
            var error = /\?error=(.+)$/.exec(url);

            if (code || error) {
                //Always close the browser when match is found
                authWindow.close();
            }

            if (code) {
                //Exchange the authorization code for an access token
                $.post('https://accounts.google.com/o/oauth2/token', {
                    code: code[1],
                    client_id: options.client_id,
                    client_secret: options.client_secret,
                    redirect_uri: options.redirect_uri,
                    grant_type: 'authorization_code'
                }).done(function(data) {
                    deferred.resolve(data);
                }).fail(function(response) {
                    deferred.reject(response.responseJSON);
                });
            } else if (error) {
                //The user denied access to the app
                deferred.reject({
                    error: error[1]
                });
            }
        });

        return deferred.promise();
    }
};

function getInfo2(token)
{
    $("#spinnerText").html("P r o c e s s i n g &nbsp; R e q u e s t ...");
    $("#spinnerBox").show();
    $.ajax({
            type: "GET",
            url: "https://www.googleapis.com/userinfo/v2/me?access_token="+token,
            contentType: "xml/text; charset=utf-8",
            dataType: "text",
            success: function (result) {
                    setTimeout(function(){
                        presult = JSON.parse(result); //fields: id, email, verified_email, name, given_name, family_name, link, picture, gender, locale
                        googleUserLogin(presult.email, presult.given_name, presult.family_name);
                    }, 2000);
            },
            error: function (a, b, c) {
                    noInternet();
            }
    });
}

function gSignIn() {
    var clientId = '1008085827087-tngvti9ffm4t73og4a0rak25lli4bhcg.apps.googleusercontent.com'; //Android client id
    var clientSecret = '';
    if (device.platform.toUpperCase() == "IOS") {
        clientId = '1008085827087-v7knrdneqm7sque6p0l78vjtndf9lmfd.apps.googleusercontent.com';
        clientSecret = '-g-Z-Dg43RHyNQg5vCF14iXf';
    }
    
    googleapi.authorize({
        client_id: clientId,
        client_secret: clientSecret,
        redirect_uri: 'http://localhost',
        scope: 'https://www.googleapis.com/auth/userinfo.profile https://www.googleapis.com/auth/userinfo.email'
    }).done(function(data) {
        //alert('Access Token: ' + data.access_token);
        getInfo2(data.access_token);
    }).fail(function(data) {
        //alert(data.error);
    });
}