/*
 * Author: shadow476z@gmail.com
 * Date: 6Mar2015
 * Purpose: Functions used for remote communication.
 * 
 */
baseUrl = "http://67minutes.org.za/ws.php?";

//retrieve project listing for specified criteria
//filters: name, category, location
function getProjects(filter, value) {
    if (filter == "name" && value == "") {
	value = "*";
    }
    if (filter == "name") {
	    $("#nameSearchResult").html("<center><img class='spinner' src='img/295.GIF' /></center>"); 
    } else if (filter == "category") {
	    $("#categorySearch").html("<center><img class='spinner' src='img/295.GIF' /></center>"); 
    }

    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=getProjects&filter=" + filter + "&value=" + value + "&featured=" + featured,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		resultList = result.Response;

		if (resultList == "") resultList = {};
		
		if (filter == "name") {
		    setResults("name");
		} else if (filter == "category") {
		    setResults("category");
		} else if (filter == "location") {
		    setResults("location");
		}
	    },
	    error: function(a, b, c) {}
    });
};

//find project info
function getDetail() {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=getProjectDetail&pid=" + projectId,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		projectInfo = result.Response;
		setDetail();
	    },
	    error: function(a, b, c) {}
    });
};

//create a new user account
function registerUser(username, email, name, surname, password, cnum, dob, province, city, address, coords) {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=addUser&username=" + username + "&email=" + email + "&name=" + name + "&surname=" + surname + "&password=" + password + "&contactNumber=" + cnum + "&dob=" +
		dob + "&province=" + province + "&city=" + city + "&address=" + address + "&coords=" + coords,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		if (result.Response == "duplicate username")
		    $("#usernameError").text("*username not available");
		if (result.Response == "duplicate email")
		    $("#emailError").text("*email exists");
		if (result.Response == "success") { //success
		    $('#registrationForm').hide();
		    $('#successMsg').show();
		}
		$("html, body").animate({ scrollTop: 0 }, "slow");
	    },
	    error: function(a, b, c) {}
    });
};

//create a new user account
function updateUser(username, email, name, surname, password, cnum, dob, province, city, address, coords) {
    $("#spinnerText").html("P r o c e s s i n g &nbsp; R e q u e s t ...");
    $("#spinnerBox").show();
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=updateUser&username=" + username + "&email=" + email + "&name=" + name + "&surname=" + surname + "&password=" + password + "&contactNumber=" + cnum + "&dob=" +
		dob + "&province=" + province + "&city=" + city + "&address=" + address + "&coords=" + coords,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    if (result.Response == "success") {
			var text1 = "Your user details was updated successfully.";
			var text2 = "";
			newMessage("User details updated!", text1, text2);
			
			//update user object
			var userObj = {username : username, email : email, name : name, surname : surname, password : password, contactnum : cnum, dob : dob, province : province, city : city, address : address, coords : coords};
			localStorage.setItem("user67minutes", JSON.stringify(userObj));    
		    }
		    if (result.Response == "email not available") {
			$("#email2Error").text("*email not available");
		    }
		    $("#spinnerBox").hide();
		    $("html, body").animate({ scrollTop: 0 }, "slow");
		}, 2000);
	    },
	    error: function(a, b, c) {
		noInternet();
	    }
    });
};

//validate user cridentials
function checkLogin(username, password) {
    $("#spinnerText").html("V e r i f y i n g &nbsp; D e t a i l s ...");
    $("#spinnerBox").show();
    
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=checkLogin&username=" + username + "&password=" + password,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    if (result.Response == "error") { //invalid usernanme/password
			var text1 = "We could not find the specified username / password on our systems.";
			var text2 = "Check that you have entered the correct information and try again.";
			newMessage("Invalid login details", text1, text2);
		    }
		    else {
			if (remember) { //permanently sign user in
			    
			    localStorage.setItem("login67minutes", "true");
			    
			    var userObj = result.Response; //create user object with user details
			    userObj.password = password;
			    
			    localStorage.setItem("user67minutes", JSON.stringify(userObj));
			}
			
			changeFromLogin();
		    }
		}, 4000);
	    },
	    error: function(a, b, c) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    var text1 = "We were unable to verify your details because the request timed out.";
		    var text2 = "Check that your Internet connection is active or try again later.";
		    newMessage("Request timeout", text1, text2);
		    
		}, 4000);
	    }
    });
};

//add verified google account details to database
function googleUserLogin(email, name, surname)
{
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=addOtherLogin&email=" + email + "&name=" + name + "&surname=" + surname,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    $("#spinnerBox").hide();

		    if (remember) { //permanently sign user in
			localStorage.setItem("login67minutes", "true");

			var userObj = result.Response; //create user object with user details
			userObj.password = '';
			localStorage.setItem("user67minutes", JSON.stringify(userObj));
		    }
                    changeFromLogin();
                    
                    //google first time sign in
                    if (localStorage.getItem("gsignin67minutes") == null) {
                        localStorage.setItem("gsignin67minutes", "done");
                        var text1 = "You have signed in with Google!";
                        var text2 = "To update your non-google account details click <u><b><span onclick=\"$('#overlay').hide(); $('#msg').hide(); changeProfile();\">here</span></b></u>.";
                        newMessage("Welcome " + name + " " + surname, text1, text2);
                    }
		}, 2000);
	    },
	    error: function(a, b, c) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    var text1 = "We were unable to verify your details because the request timed out.";
		    var text2 = "Check that your Internet connection is active or try again later.";
		    newMessage("Request timeout", text1, text2);
		}, 4000);
	    }
    });
}

//add facebook account details to database
function facebookUserLogin(email, name, surname, image)
{
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=addOtherLogin&email=" + email + "&name=" + name + "&surname=" + surname,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    $("#spinnerBox").hide();

		    if (remember) { //permanently sign user in
			localStorage.setItem("login67minutes", "true");

			var userObj = result.Response; //create user object with user details
			userObj.password = '';
			localStorage.setItem("user67minutes", JSON.stringify(userObj));
		    }
                    changeFromLogin();
                    
                    //facebook first time sign in
                    if (localStorage.getItem("fsignin67minutes") == null) {
                        localStorage.setItem("fsignin67minutes", "done");
                        var text1 = "<img class='fbicon' src='" + image + "' /><br>" +"You have signed in with Facebook!";
                        var text2 = "To update your non-facebook account details click <u><b><span onclick=\"$('#overlay').hide(); $('#msg').hide(); changeProfile();\">here</span></b></u>.";
                        newMessage("Welcome " + name + " " + surname, text1, text2);
                    }
		}, 2000);
	    },
	    error: function(a, b, c) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    var text1 = "We were unable to verify your details because the request timed out.";
		    var text2 = "Check that your Internet connection is active or try again later.";
		    newMessage("Request timeout", text1, text2);
		}, 4000);
	    }
    });
}

//link a user to a project
function addUserProject(name, email, contactNumber, participants) {
    $("#spinnerText").html("P r o c e s s i n g &nbsp; R e q u e s t ...");
    $("#spinnerBox").show();

    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=addUserProject&username=" + getUsername() + "&name=" + name + "&projectID=" + projectId  + "&email=" + email + "&contactNumber=" + contactNumber + "&participants=" + participants,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    if (result.Response == "exists") {
			var text1 = "You have already joined this project and have since been blocked from participating in it.";
                        var text2 = "Please contact support at <i><b>support@67minutes.org.za</i></b> for assistance in this matter.";
                        newMessage("Project locked for user", text1, text2);
                    } else if (result.Response != "error") {
			$("#projectEmail").text(result.Response);
                        setJoinedBtn();
			$('#participate').hide();
			$('#page-overlay').show();
			$('#confirmation').show();
			$("#currentPeople").text(newParticipants);
			
			//update projects in browser storage
			if (localStorage.getItem("projects67minutes") != null) {
                            var projectsObj = JSON.parse(localStorage.getItem("projects67minutes"));
                            if (projectsObj == "") projectsObj = {};
			    projectsObj[""+projectId] = {"name": projectInfo.name, "title": projectInfo.title, "category": projectInfo.category, "dateStart": projectInfo.dateStart, "timeStart": projectInfo.timeStart, "email": result.Response};
                            localStorage.setItem("projects67minutes", JSON.stringify(projectsObj));
			} else {
			    var projectsObj = {};
			    projectsObj[""+projectId] = {"name": projectInfo.name, "title": projectInfo.title, "category": projectInfo.category, "dateStart": projectInfo.dateStart, "timeStart": projectInfo.timeStart, "email": result.Response};
			    localStorage.setItem("projects67minutes", JSON.stringify(projectsObj));
			}
		    }
		}, 4000);
	    },
	    error: function(a, b, c) {
                noInternet();
	    }
    });
};

//get current and past projects for signed in user 
function getUserProjects() {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=getUserProjects&username=" + getUsername(),
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		userProjects = result.Response;
		//save to browser storage
		localStorage.setItem("projects67minutes", JSON.stringify(userProjects));
	    },
	    error: function(a, b, c) {}
    });
};

//withdraw user from participating in project
function deleteUserProject(pid) {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=deleteUserProject&username=" + getUsername() + "&projectId=" + pid,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		//update projects object
		var projectsObj = JSON.parse(localStorage.getItem("projects67minutes"));
		delete projectsObj['' + pid];
		localStorage.setItem("projects67minutes", JSON.stringify(projectsObj));
		try { showProjects(); } catch(e) {}
		
		//update failed remove project list
		var projectsToRemoveObj = []
		if (localStorage.getItem("projects2r67minutes") != null) {
		    projectsToRemoveObj = JSON.parse(localStorage.getItem("projects2r67minutes"));
		}
		var index = projectsToRemoveObj.indexOf(pid);
		if (index > -1) {
		    projectsToRemoveObj.splice(index, 1);
		}
		localStorage.setItem("projects2r67minutes", JSON.stringify(projectsToRemoveObj));
	    },
	    error: function(a, b, c) { //if error then remove project at a later stage
		var projectsObj = JSON.parse(localStorage.getItem("projects67minutes"));
		delete projectsObj['' + pid];
		localStorage.setItem("projects67minutes", JSON.stringify(projectsObj));
		try { showProjects(); } catch(e) {}
		
		var projectsToRemoveObj = []
		if (localStorage.getItem("projects2r67minutes") != null) {
		    projectsToRemoveObj = JSON.parse(localStorage.getItem("projects2r67minutes"));
		}
		var index = projectsToRemoveObj.indexOf(pid);
		if (index == -1) {
		    projectsToRemoveObj.push(pid);
		    localStorage.setItem("projects2r67minutes", JSON.stringify(projectsToRemoveObj));
		}
	    }
    });
};

//set project shared state
function setSharedState(pid) {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=setSharedState&username=" + getUsername() + "&projectId=" + pid,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
	    },
	    error: function(a, b, c) {
	    }
    });
};

//forgot password request
function forgotPasswordRequest(email) {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=newPassphrase&email=" + email,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    if (result.Response == "no such email") {
			$("#fpEmailError").text("Email does not exist");
		    } else {
			$("#part1").hide();
			$("#part2").show();
		    }
		}, 4000);
	    },
	    error: function(a, b, c) {
		noInternet();
	    }
    });
};

//verify forgot password passphrase
function verifyPassphrase(email, passphrase) {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=checkPassphrase&email=" + email + "&passphrase=" + passphrase,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    //check if match
		    if (result.Response == "invalid") {
			$("#fpPhraseError").text("Incorrect passphrase");
		    } else {
			$("#part2").hide();
			$("#part3").show();
		    }
		}, 4000);
	    },
	    error: function(a, b, c) {
		noInternet();
	    }
    });
};

//update user password
function changePassword(email, password) {
    $.ajax({
	    type: "POST",
	    url: baseUrl + "method=updatePassword&email=" + email + "&password=" + password,
	    contentType: "application/json; charset=utf-8",
	    dataType: "json",
	    success: function (result) {
		setTimeout(function(){
		    $("#spinnerBox").hide();
		    closeForgotPassword();
		    var text1 = "Congratulations, your password has been changed!";
		    var text2 = "";
		    newMessage("Password update complete", text1, text2);
		}, 4000);
	    },
	    error: function(a, b, c) {
		noInternet();
	    }
    });
};

function noInternet()
{
    setTimeout(function(){
	$("#spinnerBox").hide();
	var text1 = "We were unable to process your request.";
	var text2 = "Check that your Internet connection is active or try again later.";
	newMessage("Request timeout", text1, text2);
    }, 4000);
}